	page	60,132
;-----------------------------------------------------------------------------
;
; PAE_RSVD.ASM
;
;       Copyright (c) 1995-Present  Robert Collins
;
;       You have my permission to copy and distribute this software for
;       non-commercial purposes.  Any commercial use of this software or
;       source code is allowed, so long as the appropriate copyright
;       attributions (to me) are intact, *AND* my email address is properly
;       displayed.
;
;       Basically, give me credit, where credit is due, and show my email
;       address.
;
;-----------------------------------------------------------------------------
;
;       Robert R. Collins               email:  rcollins@x86.org
;
;-----------------------------------------------------------------------------


;-----------------------------------------------------------------------------
; Assembler directives
;-----------------------------------------------------------------------------
	.xlist			; disable list file
	.586P
	.ALPHA

;-----------------------------------------------------------------------------
; Include file section
;-----------------------------------------------------------------------------
%	Include INCLUDEDIR\\macros.inc	; Include macros
%	Include INCLUDEDIR\\struct.inc	; Include structures


;-----------------------------------------------------------------------------
; Public declarations
;-----------------------------------------------------------------------------
	Public	GDT_PTR,	ext_mem_blocks


;-----------------------------------------------------------------------------
; External declarations
;-----------------------------------------------------------------------------
	Extern	Init2M_Pages		:	Near16
	Extern	Check2M_Pages		:	Near16
	Extern	GetPDBR 		:	Near16
	Extern	PDBR			:	DWord


;-----------------------------------------------------------------------------
; Equates & macros
;-----------------------------------------------------------------------------
	CR3PFFailed	equ	1000000000000000y
	PDPPFFailed	equ	0100000000000000y
	PDE4MPFFailed	equ	0010000000000000y
	PDE4KPFFailed	equ	0001000000000000y
	PTE4KPFFailed	equ	0000100000000000y

	CR3RsvdFailed	equ	0000000000010000y
	PDPRsvdFailed	equ	0000000000001000y
	PDE4MRsvdFailed equ	0000000000000100y
	PDE4KRsvdFailed equ	0000000000000010y
	PTE4KRsvdFailed equ	0000000000000001y


	.list
;-----------------------------------------------------------------------------
; Dummy segments
;-----------------------------------------------------------------------------
        INTSEG  segment at 0
        int0    dd      ?
	int1	dd	?
	int2	dd	?
	int3	dd	?
	int4	dd	?
	int5	dd	?
	int6	dd	?
        INTSEG  ends


	_DATA segment para public use16 'DATA'
;-----------------------------------------------------------------------------
; Data segment
;-----------------------------------------------------------------------------
	GDT_386 label	fword
	GDT_PTR 	Descriptor	<>
	SEL_RMCS	equ	$-GDT_386
	GDT_RMCS	Descriptor	<-1,,,9bh,0,>	; DS Descriptor
	SEL_RMDS	equ	$-GDT_386
	GDT_RMDS	Descriptor	<-1,,,93h,0,>	; DS Descriptor
	SEL_PGDIR	equ	$-GDT_386
	GDT_PGDIR	Descriptor	<-1,,,93h,0,>	; DS Descriptor
	SEL_RMSS	equ	$-GDT_386
	GDT_RMSS	Descriptor	<-1,,,93h,0,>	; SS Descriptor
	SEL_4G		equ		$-GDT_386
	GDT_4G		Descriptor	<-1h,0,0h,93h,8fh,0h>	   ; 4G Descriptor
	GDT_Len 	equ	($-GDT_386) - 1


;-----------------------------------------------------------------------------
; Interrupt descriptor table
;-----------------------------------------------------------------------------
	IDT_386 INT_Desc	<Offset INT00,SEL_RMCS>    ; INT00
		INT_Desc	<Offset INT01,SEL_RMCS>    ; INT01
		INT_Desc	<Offset INT02,SEL_RMCS>    ; INT02
		INT_Desc	<Offset INT03,SEL_RMCS>    ; INT03
		INT_Desc	<Offset INT04,SEL_RMCS>    ; INT04
		INT_Desc	<Offset INT05,SEL_RMCS>    ; INT05
		INT_Desc	<Offset INT06,SEL_RMCS>    ; INT06
		INT_Desc	<Offset INT07,SEL_RMCS>    ; INT07
		INT_Desc	<Offset INT08,SEL_RMCS>    ; INT08
		INT_Desc	<Offset INT09,SEL_RMCS>    ; INT09
		INT_Desc	<Offset INT0a,SEL_RMCS>    ; INT0a
		INT_Desc	<Offset INT0b,SEL_RMCS>    ; INT0b
		INT_Desc	<Offset INT0c,SEL_RMCS>    ; INT0c
		INT_Desc	<Offset INT0d,SEL_RMCS>    ; INT0d
		INT_Desc	<Offset INT0e,SEL_RMCS>    ; INT0e
		INT_Desc	<Offset INT0f,SEL_RMCS>    ; INT0f
		INT_Desc	<Offset INT10,SEL_RMCS>    ; INT10
		INT_Desc	<Offset INT11,SEL_RMCS>    ; INT11
		INT_Desc	<Offset INT12,SEL_RMCS>    ; INT12
		INT_Desc	<Offset INT13,SEL_RMCS>    ; INT13
		INT_Desc	<Offset INT14,SEL_RMCS>    ; INT14
		INT_Desc	<Offset INT15,SEL_RMCS>    ; INT15
		INT_Desc	<Offset INT16,SEL_RMCS>    ; INT16
		INT_Desc	<Offset INT17,SEL_RMCS>    ; INT17
		INT_Desc	<Offset INT18,SEL_RMCS>    ; INT18
		INT_Desc	<Offset INT19,SEL_RMCS>    ; INT19
		INT_Desc	<Offset INT1a,SEL_RMCS>    ; INT1a
		INT_Desc	<Offset INT1b,SEL_RMCS>    ; INT1b
		INT_Desc	<Offset INT1c,SEL_RMCS>    ; INT1c
		INT_Desc	<Offset INT1d,SEL_RMCS>    ; INT1d
		INT_Desc	<Offset INT1e,SEL_RMCS>    ; INT1e
		INT_Desc	<Offset INT1f,SEL_RMCS>    ; INT1f
		INT_Desc	<Offset INT20,SEL_RMCS>    ; INT20
		INT_Desc	<Offset INT21,SEL_RMCS>    ; INT21
		INT_Desc	<Offset INT22,SEL_RMCS>    ; INT22
		INT_Desc	<Offset INT23,SEL_RMCS>    ; INT23
		INT_Desc	<Offset INT24,SEL_RMCS>    ; INT24
		INT_Desc	<Offset INT25,SEL_RMCS>    ; INT25
		INT_Desc	<Offset INT26,SEL_RMCS>    ; INT26
		INT_Desc	<Offset INT27,SEL_RMCS>    ; INT27
		INT_Desc	<Offset INT28,SEL_RMCS>    ; INT28
		INT_Desc	<Offset INT29,SEL_RMCS>    ; INT29
		INT_Desc	<Offset INT2a,SEL_RMCS>    ; INT2a
		INT_Desc	<Offset INT2b,SEL_RMCS>    ; INT2b
		INT_Desc	<Offset INT2c,SEL_RMCS>    ; INT2c
		INT_Desc	<Offset INT2d,SEL_RMCS>    ; INT2d
		INT_Desc	<Offset INT2e,SEL_RMCS>    ; INT2e
		INT_Desc	<Offset INT2f,SEL_RMCS>    ; INT2f
	IDT3_Len	equ	$-IDT_386


;-----------------------------------------------------------------------------
; All other data
;-----------------------------------------------------------------------------
	PSEMsg0 	db	"Page faults                Taken          RsvdBits          Expected",CRLF$
	CR3RsvdMsg	db	"CR3             $"
	CR3Buf1a	db	"00000000"
	CR3Buf1b	db	"00000000  "
	CR3Buf2a	db	"00000000"
	CR3Buf2b	db	"00000000  "
	CR3Buf3a	db	"00000000"
	CR3Buf3b	db	"00000000",CRLF$
	PDPRsvdMsg	db	"PDP             $"
	PDE4MRsvdMsg	db	"PDE 2MB         $"
	PDE4KRsvdMsg	db	"PDE 4KB         $"
	PTE4KRsvdMsg	db	"PTE 4KB         $"
	PassMsg 	db	"All tests passed",CRLF$
	FailMsg 	db	"Some tests failed:  $"

	ext_mem_blocks	dw	0

	align
	RM_IDT3_Ptr	dw	256*4
			dd	0
			dw	0
	IDT3_Ptr	label	Descriptor
			dw	IDT3_Len-1
			dd	0
			dw	0

;				6666555555555544444444443333333333222222222211111111110000000000
;				3210987654321098765432109876543210987654321098765432109876543210
	CR3_Mask	dq	0000000000000000000000000000111111111111111111111111000000000001y
	CR3_Rsvd	dq	1111111111111111111111111111000000000000000000000000000111100110y
	CR3_Init	dq	0000000000000000000000000000000000000000000000000000000000000010y
	CR3_PF		dq	0000000000000000000000000000000000000000000000000000000000000000y
	CR3_PFRsvd	dq	0000000000000000000000000000000000000000000000000000000000000000y

	PDP_Mask	dq	0000000000000000000000000000111111111111111111111111000000000001y
	PDP_Rsvd	dq	0000000000000000000000000000000000000000000000000000000000000000y
	PDP_Init	dq	0000000000000000000000000000000000000000000000000000000000000010y
	PDP_PF		dq	0000000000000000000000000000000000000000000000000000000000000000y
	PDP_PFRsvd	dq	0000000000000000000000000000000000000000000000000000000000000000y

	PDE4M_Mask	dq	0000000000000000000000000000111111111111111000000000000010111111y
	PDE4M_Rsvd	dq	1111111111111111111111111111000000000000000111111111000000000000y
	PDE4M_Init	dq	0000000000000000000000000000000000000000000000000000000001000000y
	PDE4M_PF	dq	0000000000000000000000000000000000000000000000000000000000000000y
	PDE4M_PFRsvd	dq	0000000000000000000000000000000000000000000000000000000000000000y

	PDE4K_Mask	dq	0000000000000000000000000000111111111111111111111111000010111111y
	PDE4K_Rsvd	dq	1111111111111111111111111111000000000000000000000000000000000000y
	PDE4K_Init	dq	0000000000000000000000000000000000000000000000000000000001000000y
	PDE4K_PF	dq	0000000000000000000000000000000000000000000000000000000000000000y
	PDE4K_PFRsvd	dq	0000000000000000000000000000000000000000000000000000000000000000y

	PTE4K_Mask	dq	0000000000000000000000000000111111111111111111111111000000111111y
	PTE4K_Rsvd	dq	1111111111111111111111111111000000000000000000000000000010000000y
	PTE4K_Init	dq	0000000000000000000000000000000000000000000000000000000001000000y
	PTE4K_PF	dq	0000000000000000000000000000000000000000000000000000000000000000y
	PTE4K_PFRsvd	dq	0000000000000000000000000000000000000000000000000000000000000000y

	PassFail	dd					00000000000000000000000000000000y

	_DATA	ENDS

	_TEXT	segment para public use16 'CODE'
	ASSUME	CS:_TEXT, DS:_DATA, ES:_DATA, SS:STACK

;-----------------------------------------------------------------------------
; Code starts here
;-----------------------------------------------------------------------------
	PAE_RSVD	proc	far
	mov	ax,seg STACK		; setup stack segment
	mov	ss,ax
	mov	sp,sizeof StackPtr
	xor	ax,ax			; clear it
	pushf
	push	ds			; save far return on stack
	push	ax

;-----------------------------------------------------------------------------
; Set segments to normal data segment
;-----------------------------------------------------------------------------
	mov	ax,seg _DATA		; get original data segment
	mov	ds,ax
	mov	es,ax

;-----------------------------------------------------------------------------
; Check that this processor supports 2M pages.
;-----------------------------------------------------------------------------
	call	Check2M_Pages		; does this processor support 4M pages?
	jnc	@F			; yes, continue

@ErrorExit:
	mov	ah,9
	int	21h			; print message
	mov	ax,4c01h		; set error code
	int	21h
	iret				; go split, just in case

;-----------------------------------------------------------------------------
; Print initial message
;-----------------------------------------------------------------------------
@@:	mov	ah,9			; get function#
	mov	dx,offset PSEMsg0	; get offset of message
	int	21h			; print message

;-----------------------------------------------------------------------------
; Setup descriptor table
;-----------------------------------------------------------------------------
	mov	eax,ds			; make pointer to GDT table
	shl	eax,4			; have physical address of segment
	add	eax,offset GDT_386	; now have physical addr of table
	mov	GDT_PTR.Seg_limit,GDT_Len	; set length
	mov	GDT_PTR.Base_A15_A00,ax
	shr	eax,10h 		; get other address bits
	mov	GDT_PTR.Base_A23_A16,al
	mov	GDT_PTR.Access_rights,ah

	mov	eax,ds			; make pointer to IDT table
	shl	eax,4			; have physical address of segment
	add	eax,offset IDT_386	; now have physical addr of table
	mov	dword ptr Idt3_Ptr[2],eax

	mov	eax,cs			; get CS
	shl	eax,4			; now have physical address
	mov	GDT_RMCS.Base_A15_A00,ax
	shr	eax,10h 		; get other address bits
	mov	GDT_RMCS.Base_A23_A16,al
	mov	GDT_RMCS.Base_A31_A24,ah

	mov	eax,ds			; get DS
	shl	eax,4			; now have physical address
	mov	GDT_RMDS.Base_A15_A00,ax
	shr	eax,10h 		; get other address bits
	mov	GDT_RMDS.Base_A23_A16,al
	mov	GDT_RMDS.Base_A31_A24,ah

	mov	eax,ss			; get SS
	shl	eax,4			; now have physical address
	mov	GDT_RMSS.Base_A15_A00,ax
	shr	eax,10h 		; get other address bits
	mov	GDT_RMSS.Base_A23_A16,al
	mov	GDT_RMSS.Base_A31_A24,ah

;-----------------------------------------------------------------------------
; Initialize page mode
;-----------------------------------------------------------------------------
	call	GetPDBR 		; get address of page directory
	jc	@ErrorExit		; oops
	mov	PDBR,edx		; save it
	mov	al,18h
	out	70h,al
	IO_Delay
	in	al,71h
	mov	ah,al
	mov	al,17h
	out	70h,al
	IO_Delay
	in	al,71h
	mov	ext_mem_blocks,ax

	cli
	lgdt	GDT_386
	Lidt	fword ptr IDT3_Ptr
	mov	eax,cr0 		; get control register
	or	al,1			;
	mov	cr0,eax
	push	cs			; push return selector on stack
	push	offset PMRET		; set return offset
	JMPFAR	@F,SEL_RMCS

@@:	mov	ax,SEL_RMDS		; get DS selector
	mov	ds,ax
	mov	ax,SEL_PGDIR		; get ES selector
	mov	es,ax
	mov	ax,SEL_4G		; get GS selector
	mov	gs,ax
	mov	ax,SEL_RMSS		; get SS selector
	mov	ss,ax

;-----------------------------------------------------------------------------
; Enable page mode
;-----------------------------------------------------------------------------
	call	Init2M_Pages
	mov	ebx,PDBR		; initialize CR3
	mov	cr3,ebx
	mov	ebx,cr4 		; get CR4
	or	bx,PAE + PSE		; enable 2M pages
	mov	cr4,ebx
	mov	ebx,cr0 		; get 386 control register
	or	ebx,80000000h		; set PG bit
	mov	cr0,ebx 		; now we're in protected mode
	jmp	short @F

;-----------------------------------------------------------------------------
; Check for reserved bits in the page directory pointer structure to cause
; #GP when move to CR3.
;-----------------------------------------------------------------------------
@@:	mov	ecx,3fh 		; initialize loop count

@CR3Loop:
	push	ecx			; save loop count
	mov	ebx,dword ptr CR3_Init[0]	; get bit to test
	mov	ecx,dword ptr CR3_Init[4]
	mov	esi,dword ptr CR3_Mask[0]	; get mask value
	mov	edi,dword ptr CR3_Mask[4]
	mov	ebp,PDBR			; get page directory base pointer
	and	gs:[ebp][08h],esi		; mask out unwanted values
	and	gs:[ebp][0ch],edi
	not	esi				; invert mask
	not	edi
	and	ebx,esi 			; don't set any unwanted bits
	and	ecx,edi
	mov	esi,dword ptr CR3_Mask[0]	; get mask value
	mov	edi,dword ptr CR3_Mask[4]
	or	gs:[ebp][08h],ebx		; set appropriate bit
	or	gs:[ebp][0ch],ecx
	xor	eax,eax 			; clear page fault bits
	xor	edx,edx
	xor	esi,esi
	xor	edi,edi
	mov	ebx,dword ptr CR3_Init[0]	; get bit to test
	mov	ecx,dword ptr CR3_Init[4]
	mov	ecx,cr3 			; get CR3
	mov	cr3,ecx 			; flush TLB

	mov	ebp,gs:[000000000h]	 ; invoke page translation
	mov	ebp,gs:[040000000h]	 ; invoke page translation
	mov	ebp,gs:[080000000h]	 ; invoke page translation
	mov	ebp,gs:[0C0000000h]	 ; invoke page translation

	or	dword ptr CR3_PF[0],eax ; save off error code
	or	dword ptr CR3_PF[4],edx
	or	dword ptr CR3_PFRsvd[0],esi	; save off other error code
	or	dword ptr CR3_PFRsvd[4],edi
	shl	dword ptr CR3_Init[0],1 	; try next bit position
	rcl	dword ptr CR3_Init[4],1
	pop	ecx
	dec	ecx			; are we done yet?
	jnz	@CR3Loop		; nope

	mov	eax,dword ptr CR3_PF[0] ; get error codes
	mov	edx,dword ptr CR3_PF[4]
	mov	esi,dword ptr CR3_PFRsvd[0]
	mov	edi,dword ptr CR3_PFRsvd[4]

	cmp	eax,dword ptr CR3_Rsvd[0]	; did results match?
	je	@F				; nope
	or	PassFail,CR3PFFailed
@@:	cmp	edx,dword ptr CR3_Rsvd[4]	; did results match?
	je	@F				; nope
	or	PassFail,CR3PFFailed

;-----------------------------------------------------------------------------
; Fix up page directory pointer
;-----------------------------------------------------------------------------
@@:	mov	esi,dword ptr PDP_Mask[0]	; get mask value
	mov	edi,dword ptr PDP_Mask[4]
	mov	ebp,PDBR			; get page directory base pointer
	and	gs:[ebp][08h],esi		; mask out unwanted values
	and	gs:[ebp][0ch],edi
	mov	eax,cr3 			; get feature control register
	mov	cr3,eax

;-----------------------------------------------------------------------------
; Check for reserved bits in the page directory pointer structure
;-----------------------------------------------------------------------------
@@:	mov	ecx,3fh 		; initialize loop count

@PDPLoop:
	push	ecx			; save loop count
	mov	ebx,dword ptr PDP_Init[0]	; get bit to test
	mov	ecx,dword ptr PDP_Init[4]
	mov	esi,dword ptr PDP_Mask[0]	; get mask value
	mov	edi,dword ptr PDP_Mask[4]
	mov	ebp,PDBR			; get page directory base pointer
	and	gs:[ebp][08h],esi		; mask out unwanted values
	and	gs:[ebp][0ch],edi
	not	esi				; invert mask
	not	edi
	and	ebx,esi 			; don't set any unwanted bits
	and	ecx,edi
	mov	esi,dword ptr PDP_Mask[0]	; get mask value
	mov	edi,dword ptr PDP_Mask[4]
	or	gs:[ebp][08h],ebx		; set appropriate bit
	or	gs:[ebp][0ch],ecx
	invlpg	gs:[40000000h]			; inalidate this TLB entry
	xor	eax,eax 			; clear page fault bits
	xor	edx,edx
	xor	esi,esi
	xor	edi,edi
	mov	ebx,dword ptr PDP_Init[0]	; get bit to test
	mov	ecx,dword ptr PDP_Init[4]

	mov	ebp,gs:[40000000h]	; invoke page translation
	or	dword ptr PDP_PF[0],eax ; save off error code
	or	dword ptr PDP_PF[4],edx
	or	dword ptr PDP_PFRsvd[0],esi	; save off other error code
	or	dword ptr PDP_PFRsvd[4],edi
	shl	dword ptr PDP_Init[0],1 	; try next bit position
	rcl	dword ptr PDP_Init[4],1
	pop	ecx
	dec	ecx			; are we done yet?
	jnz	@PDPLoop		; nope

	mov	eax,dword ptr PDP_PF[0] ; get error codes
	mov	edx,dword ptr PDP_PF[4]
	mov	esi,dword ptr PDP_PFRsvd[0]
	mov	edi,dword ptr PDP_PFRsvd[4]

	cmp	eax,dword ptr PDP_Rsvd[0]	; did results match?
	je	@F				; nope
	or	PassFail,PDPPFFailed
@@:	cmp	edx,dword ptr PDP_Rsvd[4]	; did results match?
	je	@F				; nope
	or	PassFail,PDPPFFailed
@@:	cmp	esi,dword ptr PDP_Rsvd[0]	; did results match?
	je	@F				; nope
	or	PassFail,PDPRsvdFailed
@@:	cmp	edi,dword ptr PDP_Rsvd[4]	; did results match?
	je	@F				; nope
	or	PassFail,PDPRsvdFailed

;-----------------------------------------------------------------------------
; Flush TLB and modify a PDE for a 2M page
;-----------------------------------------------------------------------------
@@:	mov	esi,dword ptr PDP_Mask[0]	; get mask value
	mov	edi,dword ptr PDP_Mask[4]
	mov	ebp,PDBR			; get page directory base pointer
	and	gs:[ebp][08h],esi		; mask out unwanted values
	and	gs:[ebp][0ch],edi
	or	dword ptr gs:[ebp][1010h],1 SHL 7 ; modify to 2M page size
	mov	eax,cr3 			; get feature control register
	mov	cr3,eax

;-----------------------------------------------------------------------------
; Check for reserved bits in the page directory pointer structure
;-----------------------------------------------------------------------------
@@:	mov	ecx,3ah 		; initialize loop count

@PDE4MLoop:
	push	ecx			; save loop count
	mov	ebp,PDBR			; get address of PDE
	mov	ebx,dword ptr PDE4M_Init[0]	; get bit to test
	mov	ecx,dword ptr PDE4M_Init[4]
	mov	esi,dword ptr PDE4M_Mask[0]	; get mask value
	mov	edi,dword ptr PDE4M_Mask[4]
	and	gs:[ebp][1010h],esi		; mask out unwanted values
	and	gs:[ebp][1014h],edi
	not	esi				; invert mask
	not	edi
	and	ebx,esi 			; don't set any unwanted bits
	and	ecx,edi
	mov	esi,dword ptr PDE4M_Mask[0]	; get mask value
	mov	edi,dword ptr PDE4M_Mask[4]
	or	gs:[ebp][1010h],ebx		; set appropriate bit
	or	gs:[ebp][1014h],ecx
	invlpg	gs:[400000h]			; inalidate this TLB entry
	xor	eax,eax 			; clear page fault bits
	xor	edx,edx
	xor	esi,esi
	xor	edi,edi
	mov	ebx,dword ptr PDE4M_Init[0]	; get bit to test
	mov	ecx,dword ptr PDE4M_Init[4]

	mov	ebp,gs:[400000h]	  ; invoke page translation
	or	dword ptr PDE4M_PF[0],eax ; save off error code
	or	dword ptr PDE4M_PF[4],edx
	or	dword ptr PDE4M_PFRsvd[0],esi	; save off other error code
	or	dword ptr PDE4M_PFRsvd[4],edi
	shl	dword ptr PDE4M_Init[0],1	; try next bit position
	rcl	dword ptr PDE4M_Init[4],1
	pop	ecx
	dec	ecx			  ; are we done yet?
	jnz	@PDE4MLoop		  ; nope

	mov	eax,dword ptr PDE4M_PF[0] ; get error codes
	mov	edx,dword ptr PDE4M_PF[4]
	mov	esi,dword ptr PDE4M_PFRsvd[0]
	mov	edi,dword ptr PDE4M_PFRsvd[4]

	cmp	eax,dword ptr PDE4M_Rsvd[0]	; did results match?
	je	@F				; nope
	or	PassFail,PDE4MPFFailed
@@:	cmp	edx,dword ptr PDE4M_Rsvd[4]	; did results match?
	je	@F				; nope
	or	PassFail,PDE4MPFFailed
@@:	cmp	esi,dword ptr PDE4M_Rsvd[0]	; did results match?
	je	@F				; nope
	or	PassFail,PDE4MRsvdFailed
@@:	cmp	edi,dword ptr PDE4M_Rsvd[4]	; did results match?
	je	@F				; nope
	or	PassFail,PDE4MRsvdFailed

;-----------------------------------------------------------------------------
; Flush TLB
;-----------------------------------------------------------------------------
@@:	mov	eax,cr3 		; get feature control register
	mov	cr3,eax

;-----------------------------------------------------------------------------
; Check for reserved bits in the page directory pointer structure
;-----------------------------------------------------------------------------
	mov	ecx,3ah 		; initialize loop count

@PDE4KLoop:
	push	ecx			; save loop count
	mov	ebp,PDBR			; get address of PDE
	mov	ebx,dword ptr PDE4K_Init[0]	; get bit to test
	mov	ecx,dword ptr PDE4K_Init[4]
	mov	esi,dword ptr PDE4K_Mask[0]	; get mask value
	mov	edi,dword ptr PDE4K_Mask[4]
	and	gs:[ebp][1018h],esi		; mask out unwanted values
	and	gs:[ebp][101Ch],edi
	not	esi				; invert mask
	not	edi
	and	ebx,esi 			; don't set any unwanted bits
	and	ecx,edi
	mov	esi,dword ptr PDE4K_Mask[0]	; get mask value
	mov	edi,dword ptr PDE4K_Mask[4]
	or	gs:[ebp][1018h],ebx		; set appropriate bit
	or	gs:[ebp][101Ch],ecx
	invlpg	gs:[600000h]			; inalidate this TLB entry
	xor	eax,eax 			; clear page fault bits
	xor	edx,edx
	xor	esi,esi
	xor	edi,edi
	mov	ebx,dword ptr PDE4K_Init[0]	; get bit to test
	mov	ecx,dword ptr PDE4K_Init[4]

	mov	ebp,gs:[600000h]		; invoke page translation
	or	dword ptr PDE4K_PF[0],eax	; save off error code
	or	dword ptr PDE4K_PF[4],edx
	or	dword ptr PDE4K_PFRsvd[0],esi	; save off other error code
	or	dword ptr PDE4K_PFRsvd[4],edi
	shl	dword ptr PDE4K_Init[0],1	; try next bit position
	rcl	dword ptr PDE4K_Init[4],1
	pop	ecx
	dec	ecx			  ; are we done yet?
	jnz	@PDE4KLoop		  ; nope

	mov	eax,dword ptr PDE4K_PF[0] ; get error codes
	mov	edx,dword ptr PDE4K_PF[4]
	mov	esi,dword ptr PDE4K_PFRsvd[0]
	mov	edi,dword ptr PDE4K_PFRsvd[4]

	cmp	eax,dword ptr PDE4K_Rsvd[0]	; did results match?
	je	@F				; nope
	or	PassFail,PDE4KPFFailed
@@:	cmp	edx,dword ptr PDE4K_Rsvd[4]	; did results match?
	je	@F				; nope
	or	PassFail,PDE4KPFFailed
@@:	cmp	esi,dword ptr PDE4K_Rsvd[0]	; did results match?
	je	@F				; nope
	or	PassFail,PDE4KRsvdFailed
@@:	cmp	edi,dword ptr PDE4K_Rsvd[4]	; did results match?
	je	@F				; nope
	or	PassFail,PDE4KRsvdFailed

;-----------------------------------------------------------------------------
; Flush TLB
;-----------------------------------------------------------------------------
@@:	mov	esi,dword ptr PDE4K_Mask[0]	; get mask value
	mov	edi,dword ptr PDE4K_Mask[4]
	mov	ebp,PDBR			; get address of PDE
	and	gs:[ebp][1018h],esi		; mask out unwanted values
	and	gs:[ebp][101Ch],edi
	mov	eax,cr3 		; get feature control register
	mov	cr3,eax

;-----------------------------------------------------------------------------
; Check for reserved bits in the page directory pointer structure
;-----------------------------------------------------------------------------
	mov	ecx,3ah 		; initialize loop count

@PTE4KLoop:
	push	ecx			; save loop count
	mov	ebp,PDBR			; get address of PDE
	mov	ebp,gs:[ebp][1018h]		; get page directory
	and	ebp,not 0fffh			; clear non-address bits
	mov	ebx,dword ptr PTE4K_Init[0]	; get bit to test
	mov	ecx,dword ptr PTE4K_Init[4]
	mov	esi,dword ptr PTE4K_Mask[0]	; get mask value
	mov	edi,dword ptr PTE4K_Mask[4]
	and	gs:[ebp][00h],esi		; mask out unwanted values
	and	gs:[ebp][04h],edi
	not	esi				; invert mask
	not	edi
	and	ebx,esi 			; don't set any unwanted bits
	and	ecx,edi
	mov	esi,dword ptr PTE4K_Mask[0]	; get mask value
	mov	edi,dword ptr PTE4K_Mask[4]
	or	gs:[ebp][00h],ebx		; set appropriate bit
	or	gs:[ebp][04h],ecx
	invlpg	gs:[600000h]			; inalidate this TLB entry
	xor	eax,eax 			; clear page fault bits
	xor	edx,edx
	xor	esi,esi
	xor	edi,edi
	mov	ebx,dword ptr PTE4K_Init[0]	; get bit to test
	mov	ecx,dword ptr PTE4K_Init[4]

	mov	ebp,gs:[600000h]		; invoke page translation
	or	dword ptr PTE4K_PF[0],eax	; save off error code
	or	dword ptr PTE4K_PF[4],edx
	or	dword ptr PTE4K_PFRsvd[0],esi	; save off other error code
	or	dword ptr PTE4K_PFRsvd[4],edi
	shl	dword ptr PTE4K_Init[0],1	; try next bit position
	rcl	dword ptr PTE4K_Init[4],1
	pop	ecx
	dec	ecx			  ; are we done yet?
	jnz	@PTE4KLoop		  ; nope

	mov	eax,dword ptr PTE4K_PF[0] ; get error codes
	mov	edx,dword ptr PTE4K_PF[4]
	mov	esi,dword ptr PTE4K_PFRsvd[0]
	mov	edi,dword ptr PTE4K_PFRsvd[4]

	cmp	eax,dword ptr PTE4K_Rsvd[0]	; did results match?
	je	@F				; nope
	or	PassFail,PTE4KPFFailed
@@:	cmp	edx,dword ptr PTE4K_Rsvd[4]	; did results match?
	je	@F				; nope
	or	PassFail,PTE4KPFFailed
@@:	cmp	esi,dword ptr PTE4K_Rsvd[0]	; did results match?
	je	@F				; nope
	or	PassFail,PTE4KRsvdFailed
@@:	cmp	edi,dword ptr PTE4K_Rsvd[4]	; did results match?
	je	@F				; nope
	or	PassFail,PTE4KRsvdFailed

;-----------------------------------------------------------------------------
; Split from this program
;-----------------------------------------------------------------------------
@Split:
@@:	lidt	ds:fword ptr RM_IDT3_Ptr
	mov	eax,cr0 		; get 386 control register
	and	eax,not 80000001h	; clear paging bit
	mov	cr0,eax 		;   and store in CR0
	mov	edx,cr4 		; get PSE
	and	dl,not PAE + PSE	; turn off PSE
	mov	cr4,edx
	mov	edx,cr3 		; clear TLB by loading
	mov	cr3,edx 		;  CR3 with any value
	retf

PMRET:
	mov	ax,seg _DATA
	mov	ds,ax
	mov	es,ax
	mov	gs,ax
	mov	ax,seg STACK
	mov	ss,ax

;-----------------------------------------------------------------------------
; Now print the results
;-----------------------------------------------------------------------------
	mov	ah,9			; get function#
	mov	dx,offset CR3RsvdMsg	; get offset of message
	int	21h			; print message
	mov	si,offset CR3_PF
	mov	di,offset CR3Buf1a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	si,offset CR3_PFRsvd
	mov	di,offset CR3Buf2a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	eax,dword ptr CR3_Rsvd[0]
	mov	dword ptr CR3_PFRsvd[0],eax
	mov	eax,dword ptr CR3_Rsvd[4]
	mov	dword ptr CR3_PFRsvd[4],eax
	mov	si,offset CR3_PFRsvd
	mov	di,offset CR3Buf3a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	ah,9h			; print string function
	mov	dx,offset CR3Buf1a
	int	21h

	mov	ah,9			; get function#
	mov	dx,offset PDPRsvdMsg	; get offset of message
	int	21h			; print message
	mov	si,offset PDP_PF
	mov	di,offset CR3Buf1a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	si,offset PDP_PFRsvd
	mov	di,offset CR3Buf2a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	eax,dword ptr PDP_Rsvd[0]
	mov	dword ptr PDP_PFRsvd[0],eax
	mov	eax,dword ptr PDP_Rsvd[4]
	mov	dword ptr PDP_PFRsvd[4],eax
	mov	si,offset PDP_PFRsvd
	mov	di,offset CR3Buf3a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	ah,9h			; print string function
	mov	dx,offset CR3Buf1a
	int	21h

	mov	ah,9			; get function#
	mov	dx,offset PDE4MRsvdMsg	; get offset of message
	int	21h			; print message
	mov	si,offset PDE4M_PF
	mov	di,offset CR3Buf1a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	si,offset PDE4M_PFRsvd
	mov	di,offset CR3Buf2a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	eax,dword ptr PDE4M_Rsvd[0]
	mov	dword ptr PDE4M_PFRsvd[0],eax
	mov	eax,dword ptr PDE4M_Rsvd[4]
	mov	dword ptr PDE4M_PFRsvd[4],eax
	mov	si,offset PDE4M_PFRsvd
	mov	di,offset CR3Buf3a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	ah,9h			; print string function
	mov	dx,offset CR3Buf1a
	int	21h

	mov	ah,9			; get function#
	mov	dx,offset PDE4KRsvdMsg	; get offset of message
	int	21h			; print message
	mov	si,offset PDE4K_PF
	mov	di,offset CR3Buf1a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	si,offset PDE4K_PFRsvd
	mov	di,offset CR3Buf2a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	eax,dword ptr PDE4K_Rsvd[0]
	mov	dword ptr PDE4K_PFRsvd[0],eax
	mov	eax,dword ptr PDE4K_Rsvd[4]
	mov	dword ptr PDE4K_PFRsvd[4],eax
	mov	si,offset PDE4K_PFRsvd
	mov	di,offset CR3Buf3a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	ah,9h			; print string function
	mov	dx,offset CR3Buf1a
	int	21h

	mov	ah,9			; get function#
	mov	dx,offset PTE4KRsvdMsg	; get offset of message
	int	21h			; print message
	mov	si,offset PTE4K_PF
	mov	di,offset CR3Buf1a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	si,offset PTE4K_PFRsvd
	mov	di,offset CR3Buf2a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	eax,dword ptr PTE4K_Rsvd[0]
	mov	dword ptr PTE4K_PFRsvd[0],eax
	mov	eax,dword ptr PTE4K_Rsvd[4]
	mov	dword ptr PTE4K_PFRsvd[4],eax
	mov	si,offset PTE4K_PFRsvd
	mov	di,offset CR3Buf3a
	mov	cx,8			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	ah,9h			; print string function
	mov	dx,offset CR3Buf1a
	int	21h


	mov	ah,9h			; print string function
	mov	dx,offset PassMsg
	cmp	PassFail,0		; all tests pass?
	je	@F			; yes, go split
	mov	dx,offset FailMsg
	int	21h
	mov	si,offset PassFail
	mov	di,offset CR3Buf3b
	mov	cx,4			; # of bytes to convert
	call	Hex_String		; convert to ASCII
	mov	ah,9h			; print string function
	mov	dx,offset CR3Buf3b
@@:	int	21h
	iret				; return to DOS
	PAE_RSVD	endp


;-----------------------------------------------------------------------------
; HEX_STRING:	Convert a string of 8-bit hex numbers to ASCII.
; Input:   DS:SI = Pointer to hex data
;	   ES:DI = Buffer to get output
;	   CX	 = # of bytes to convert
; Output:  ES:DI = Filled in w/ ASCII hex#
; Register(s) modified:  CX
;-----------------------------------------------------------------------------
  Hex_String	proc	near
;-----------------------------------------------------------------------------
	jcxz	@Hex_str_exit		; go split
	push	ax			; [bp][0ah]
	push	cx			; [bp][8]
	push	dx			; [bp][6]
	push	si			; [bp][4]
	push	di			; [bp][2]
	push	bp			; [bp]
	mov	bp,sp
	add	si,cx

@@:	dec	si
	mov	al,ds:[si]		; get hex digit
	mov	dl,al
	mov	cl,4			; shift count
	rol	dl,cl
	mov	al,dl			; save it
	and	al,0fh			; keep low nibble
	daa
	add	al,0f0h
	adc	al,40h			; here is the ASCII
	stosb				; save it
	mov	cl,4			; shift count
	rol	dl,cl
	mov	al,dl			; save it
	and	al,0fh			; keep low nibble
	daa
	add	al,0f0h
	adc	al,40h			; here is the ASCII
	stosb				; save it
	dec	word ptr [bp][8]	; are we done yet?
	jnz	@B
	pop	bp
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	ax

@Hex_str_exit:
	ret
Hex_String	endp


;-----------------------------------------------------------------------------
; Interrupt routines
;-----------------------------------------------------------------------------
	INT00	label	word
	push	ax
	mov	al,20h
	out	80h,al
	pop	ax
	iret

	INT01	label	word
	push	ax
	mov	al,21h
	out	80h,al
	pop	ax
	iret

	INT02	label	word
	push	ax
	mov	al,22h
	out	80h,al
	pop	ax
	iret

	INT03	label	word
	push	ax
	mov	al,23h
	out	80h,al
	pop	ax
	iret

	INT04	label	word
	push	ax
	mov	al,24h
	out	80h,al
	pop	ax
	iret

	INT05	label	word
	push	ax
	mov	al,25h
	out	80h,al
	pop	ax
	iret

	INT06	label	word
	push	ax
	mov	al,26h
	out	80h,al
	pop	ax
	iret

	INT07	label	word
	push	ax
	mov	al,27h
	out	80h,al
	pop	ax
	iret

	INT08	label	word
	push	ax
	mov	al,28h
	out	80h,al
	pop	ax
	iret

	INT09	label	word
	push	ax
	mov	al,29h
	out	80h,al
	pop	ax
	iret

	INT0a	label	word
	push	ax
	mov	al,2ah
	out	80h,al
	pop	ax
	iret

	INT0b	label	word
	push	ax
	mov	al,2bh
	out	80h,al
	pop	ax
	iret

	INT0c	label	word
	push	ax
	mov	al,2ch
	out	80h,al
	pop	ax
	iret

;;;	INT0d	label	word
	INT0f	label	word
	push	ax
	mov	al,2fh
	out	80h,al
	pop	ax
	iret

	INT10	label	word
	push	ax
	mov	al,30h
	out	80h,al
	pop	ax
	iret

	INT11	label	word
	push	ax
	mov	al,31h
	out	80h,al
	pop	ax
	iret

	INT12	label	word
	push	ax
	mov	al,32h
	out	80h,al
	pop	ax
	iret

	INT13	label	word
	push	ax
	mov	al,33h
	out	80h,al
	pop	ax
	iret

	INT14	label	word
	push	ax
	mov	al,34h
	out	80h,al
	pop	ax
	iret

	INT15	label	word
	push	ax
	mov	al,35h
	out	80h,al
	pop	ax
	iret

	INT16	label	word
	push	ax
	mov	al,36h
	out	80h,al
	pop	ax
	iret

	INT17	label	word
	push	ax
	mov	al,37h
	out	80h,al
	pop	ax
	iret

	INT18	label	word
	push	ax
	mov	al,38h
	out	80h,al
	pop	ax
	iret

	INT19	label	word
	push	ax
	mov	al,39h
	out	80h,al
	pop	ax
	iret

	INT1a	label	word
	push	ax
	mov	al,3ah
	out	80h,al
	pop	ax
	iret

	INT1b	label	word
	push	ax
	mov	al,3bh
	out	80h,al
	pop	ax
	iret

	INT1c	label	word
	push	ax
	mov	al,3ch
	out	80h,al
	pop	ax
	iret

	INT1d	label	word
	push	ax
	mov	al,3dh
	out	80h,al
	pop	ax
	iret

	INT1e	label	word
	push	ax
	mov	al,3eh
	out	80h,al
	pop	ax
	iret

	INT1f	label	word
	push	ax
	mov	al,3fh
	out	80h,al
	pop	ax
	iret

	INT20	label	word
	INT21	label	word
	INT22	label	word
	INT23	label	word
	INT24	label	word
	INT25	label	word
	INT26	label	word
	INT27	label	word
	INT28	label	word
	INT29	label	word
	INT2a	label	word
	INT2b	label	word
	INT2c	label	word
	INT2d	label	word
	INT2e	label	word
	INT2f	label	word
	iret

	INT0d	label	word
	push	ax
	mov	al,2dh
	out	80h,al
	pop	ax
	or	eax,ebx 		; set results
	or	edx,ecx
	add	word ptr [esp][2],3
	add	sp,2			; point past error code
	iret

	INT0e	label	word
	push	ax
	mov	al,2eh
	out	80h,al
	pop	ax
	or	eax,ebx 		; set results
	or	edx,ecx
	add	word ptr [esp][2],9	; point past error code
	test	word ptr [esp],not 7
	jz	@F			; no RSV bit set
	or	esi,ebx 		; set results
	or	edi,ecx
@@:	add	sp,2			; ignore error code
	iret


_TEXT	ends


	STACK segment para public 'STACK'
;-----------------------------------------------------------------------------
; Stack segment
;-----------------------------------------------------------------------------
	StackPtr	db	400h dup (?)
	STACK	ends

	end	PAE_RSVD
